#!/usr/bin/perl
###########################################################################
#
# $VER: fkn_webmintheme/lib.pl 0.6.0 (20080222) (20010907) FKN-Systems/Ng
# Autor: FKN-Systems/Ng
# Email: webmaster@fkn-systems.de
# Internet: http://www.fkn-systems.de/_webmin
#
###########################################################################
#***********************************************************
# init_theme()
# Auslesen der Themevariablen aus der Datei theme.config
# 
sub init_theme{
	# preread
	if ( -e 'web-lib.pl' ){
		do 'web-lib.pl';
		&init_config();
	}else{
		do '../web-lib.pl';
		&init_config();
	}
	if ( -e '../fkn_theme_0.6.0/config'){
		$theme_path = '../fkn_theme_0.6.0/config';
		$theme_help = '../fkn_theme_0.6.0/help.html';
	}else{
		$theme_path = './fkn_theme_0.6.0/config';
		$theme_help = './fkn_theme_0.6.0/help.html';
	} 
	open(THEME ,"< $theme_path");
	my @temp = <THEME>;
	close (THEME);
	chomp @temp;
	#- 
	my $zeile = "";
	my $name = "";
	my $wert = "";
	my %hash = ();
	foreach $zeile (@temp){
		($name, $wert) = split "=", $zeile;
		$hash{$name} = $wert;
	}
	$nbc = $hash{nav_backcolor};
	$nfc = $hash{nav_fontcolor};
	$nlc = $hash{nav_linkcolor};
	$nalc = $hash{nav_alinkcolor};
	$nvlc = $hash{nav_vlinkcolor};
	$nff = $hash{nav_fontface};
	$ncm = $hash{nav_cssmode};
	$nl = $hash{nav_logo};
	$nbg = $hash{nav_bkgrd};
	$np = $hash{nav_position};
	$namc = $hash{nav_ammenuc};
	$namf = $hash{nav_ammenuf};
	$nmmc = $hash{nav_mmenuc};
	$nmmf = $hash{nav_mmenuf};
	$nsc = $hash{nav_subcolor};
	$nsfc = $hash{nav_subfcolor};
	$nan = $hash{nav_admname};
	$nam = $hash{nav_admmail};
	$nhtp = $hash{nav_http};
	$mh1 = $hash{main_h1color};
	$mbgcolor = $hash{main_backc};
	$mtext = $hash{main_fcolor};
	$mlink = $hash{main_linkc};
	$mbgimage = $hash{main_bgimage};
	$mhr = $hash{main_hrcolor};
	$mtbh = $hash{main_tbheaderc};
	$mtbhf = $hash{main_tbfcolor};
	$mcb = $hash{main_tbcolor};
 #-
	($nam_1, $nam_2) = split '@', $nam;
	#-
	if($nl eq 'logo_skin.gif'){
		$nl_1 = 'checked';
	}else{
		$nl_1 = ' ';
	}
	if($nbg eq 'bkgrd_skin.gif'){
		$nbg_1 = 'checked';
	}else{
		$nbg_1 = ' ';
	}
	if($ncm eq 'theme.css'){
		$ncm1='checked';
	}else{
		$ncm1='';
	}
	#################################
	$hostname = &get_system_hostname();
	$ver = &get_webmin_version();
	if ($gconfig{'real_os_type'}) {
		$ostr = "$gconfig{'real_os_type'} $gconfig{'real_os_version'}";
		}
	else {
		$ostr = "$gconfig{'os_type'} $gconfig{'os_version'}";
		}
	
	# Build a list of all modules
	&read_acl(\%acl);
	$user = $ENV{'REMOTE_USER'};
	local $risk = $gconfig{'risk_'.$base_remote_user};
	local $minfo;
	foreach $minfo (&get_all_module_infos(1)) {
		next if (!&check_os_support($minfo));
		if ($risk) {
			# Check module risk level
			next if ($risk ne 'high' && $minfo->{'risk'} &&
				 $minfo->{'risk'} !~ /$risk/);
			}
		else {
			# Check specific ACL
			next if (!$acl{$base_remote_user,$minfo->{'dir'}} &&
				 !$acl{$base_remote_user,"*"});
			}
		push(@modules, $minfo);
		}
	@modules = sort { $a->{'desc'} cmp $b->{'desc'} } @modules;
	
	# Work out what categories exist, and which is current
	&ReadParse();
	&read_file("$config_directory/webmin.catnames", \%catnames);
	foreach $m (@modules) {
		$c = $m->{'category'};
		next if ($cats{$c});
		if ($catnames{$c}) {
			$cats{$c} = $catnames{$c};
			}
		elsif ($text{"category_$c"}) {
			$cats{$c} = $text{"category_$c"};
			}
		else {
			# try to get category name from module ..
			local %mtext = &load_language($m->{'dir'});
			if ($mtext{"category_$c"}) {
				$cats{$c} = $mtext{"category_$c"};
				}
			else {
				$c = $m->{'category'} = "";
				$cats{$c} = $text{"category_$c"};
				}
			}
		}
	@cats = sort { $b cmp $a } keys %cats;
	$cats = @cats;
	$per = $cats ? 100.0 / $cats : 100;
	if (!defined($in{'cat'})) {
		# Use default category
		if (defined($gconfig{'deftab'})) {
			$in{'cat'} = $gconfig{'deftab'};
			}
		else {
			$in{'cat'} = $cats[0];
			}
		}
	elsif (!$cats{$in{'cat'}}) {
		$in{'cat'} = "";
		}
	#################################
	    #- make the loluwordslist ---
	###    my %loluwords=();
	#    my @loluwords_arr;
	#    $i=0;
	    foreach $m (@modules) {
		$tmp=$m->{'dir'};
		chomp($tmp);
		$tmp=~s/^.*?\/^.*?\/^.*?\///g;
		$loluwords{$tmp}={'LOLU'=>$tmp,'DIR'=>$m->{'dir'},'DESC'=>$m->{'desc'},'CATEGORY'=>$m->{'category'}};
	#	@loluwords_arr[$i]=($m->{'desc'});
	#	$i++;
		#print "$loluwords{$tmp} <br>";
	    }
	@loluwords_arr = sort { lc $loluwords{$a}->{'DESC'} cmp lc $loluwords{$b}->{'DESC'} } keys %loluwords;
	##@loluwords_arr = sort { $a cmp $b } @loluwords_arr;
	    #- print the lolulist -----
	#################################
}

#***********************************************************
# fwt_print_link()
# Print the link specials ----
# 
sub fwt_print_link(){
	my $_URL='<a class="lower" target="_TOP" href="/?fkn='.$in{'fkn'}.'&fkn2='.$in{'fkn2'}.'&cat='.$in{'cat'}.'&fkngo='.$loluwords{$lolu}{'LOLU'}.'&showpic='.$in{'showpic'}.'&such='.$in{'such'}.'">';
	if($in{'showpic'} == '1'){
		print ''.$_URL.'<img src="'.$loluwords{$lolu}{'DIR'}.'/images/icon.gif" width="36" height="36" alt="" vspace="3" align="middle" border="0" /></a>';
	}
	print '<small> &middot; '.$_URL,
	##print '<small><a class="lower" target="_TOP" href="/?fkn=1&fkn2='.$in{'fkn2'}.'&cat='.$in{'cat'}.'&fkngo='.$loluwords{$lolu}{'LOLU'}.'">',
		''.$loluwords{$lolu}{'DESC'}.'</a></small><br>';
}
####################
return 1;
